"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKrakenPublicObservableFromWS = exports.onKrakenPublicWSHeartbeat$ = exports.krakenPublicWS = exports.onKrakenPublicWSClosed = exports.onKrakenPublicWSOpened = void 0;
var ws_1 = __importDefault(require("ws"));
var webSocket_1 = require("rxjs/webSocket");
var Subject_1 = require("rxjs/internal/Subject");
var operators_1 = require("rxjs/operators");
exports.onKrakenPublicWSOpened = new Subject_1.Subject();
exports.onKrakenPublicWSClosed = new Subject_1.Subject();
exports.krakenPublicWS = webSocket_1.webSocket({
    protocol: 'v1',
    url: 'wss://ws.kraken.com',
    WebSocketCtor: ws_1.default,
    openObserver: exports.onKrakenPublicWSOpened,
    closeObserver: exports.onKrakenPublicWSClosed
});
exports.onKrakenPublicWSHeartbeat$ = exports.krakenPublicWS.pipe(operators_1.filter(function (_a) {
    var _b = _a.event, event = _b === void 0 ? null : _b;
    return event && event === 'heartbeat';
}));
exports.getKrakenPublicObservableFromWS = function (subscriptionData, filterFn, unsubscriptionData) {
    var publicObservable$ = exports.krakenPublicWS.multiplex(function () { return subscriptionData; }, function () { return unsubscriptionData; }, filterFn);
    return publicObservable$;
};
